<script type="text/javascript">
    RED.nodes.registerType("mydbConfig", {
        "category": "config",
        "color": "#336791",
        "defaults": {
            "name": {
                "value": ""
            },
            "host": {
                "value": "127.0.0.1",
                "required": true
            },
            "port": {
                "value": 5432,
                "required": true,
                "validate": RED.validators.number()
            },
            "database": {
                "value": "postgres",
                "required": false
            },
            "ssl": {
                "value": false
            },
            "rejectUnauthorized": {
                "value": false
            },
            "ca": {
                "value": ""
            },
            "key": {
                "value": ""
            },
            "cert": {
                "value": ""
            },
            "max": {
                "value": 10,
                "validate": RED.validators.number()
            },
            "min": {
                "value": 1,
                "validate": RED.validators.number()
            },
            "idle": {
                "value": 1000,
                "validate": RED.validators.number()
            }
        },
        "credentials": {
            "user": {
                "type": "text"
            },
            "password": {
                "type": "password"
            }
        },
        "label": function () {
            if (!this.name) {
                this.name = this.credentials.user + "@" + this.host + ":" + this.port + "/" + this.database;
            }
            return this.name;
        },
        "labelStyle": function () {
            return this.name ? "node_label_italic" : "";
        },
        "oneditprepare": function () {
            const tabs = RED.tabs.create({
                id: "mydb-config-tabs",
                onchange: function (tab) {
                    $("#mydb-config-tabs-content").children().hide();
                    $("#" + tab.id).show();
                }
            });
            tabs.addTab({
                "id": "mydb-config-tab-connection",
                "label": "Connection"
            });
            tabs.addTab({
                "id": "mydb-config-tab-security",
                "label": "Security"
            });
            tabs.addTab({
                "id": "mydb-config-tab-pool",
                "label": "Pool"
            });
        }
    });
</script>
<script type="text/html" data-template-name="mydbConfig">
    <div class="form-row">
        <label for="node-config-input-name"><i class="fa fa-tag"></i> <span>Name</span></label>
        <input type="text" id="node-config-input-name" placeholder="name">
    </div>
    <div class="form-row">
        <ul style="background: #fff; min-width: 600px; margin-bottom: 20px;" id="mydb-config-tabs"></ul>
    </div>
    <div id="mydb-config-tabs-content" style="min-height: 170px;">
        <div id="mydb-config-tab-connection" style="display: none;">
            <div class="form-row">
                <label for="node-config-input-host"><i class="fa fa-server"></i> <span>Host</span></label>
                <input class="input-append-left" type="text" id="node-config-input-host" placeholder="localhost" style="width: 40%;">
                <label for="node-config-input-port" style="margin-left: 10px; width: 30px; "> <span>Port</span></label>
                <input type="number" id="node-config-input-port" placeholder="5432" style="width:135px">
            </div>
            <div class="form-row">
                <label for="node-config-input-database"><i class="fa fa-database"></i> <span>Database</span></label>
                <input type="text" id="node-config-input-database" placeholder="postgres">
            </div>
            <div class="form-row">
                <input type="checkbox" id="node-config-input-ssl" style="display: inline-block; width: auto; vertical-align: top;">
                <label for="node-config-input-ssl" style="width: auto;"> <span>Use SSL</span></label>
            </div>
            <fieldset class ="form-row">
                <legend>Certificates</legend>
                <div class="form-row">
                    <input type="checkbox" id="node-config-input-rejectUnauthorized" style="display: inline-block; width: auto; vertical-align: top;">
                    <label for="node-config-input-rejectUnauthorized" style="width: auto;"> <span>Reject unauthorized</span></label>
                </div>
                <div class="form-row">
                    <label for="node-config-input-ca"><i class="fa fa-certificate"></i> <span>Root CA</span></label>
                    <input type="text" id="node-config-input-ca" placeholder="/path/to/root.crt">
                </div>
                <div class="form-row">
                    <label for="node-config-input-key"><i class="fa fa-certificate"></i> <span>Client key</span></label>
                    <input type="text" id="node-config-input-key" placeholder="/path/to/postgres.key">
                </div>
                <div class="form-row">
                    <label for="node-config-input-cert"><i class="fa fa-certificate"></i> <span>Client</span></label>
                    <input type="text" id="node-config-input-cert" placeholder="/path/to/postgres.crt">
                </div>
            </fieldset>
      </div>
      <div id="mydb-config-tab-security" style="display: none;">
            <div class="form-row">
                <label for="node-config-input-user"><i class="fa fa-user"></i> <span>User</span></label>
                <input type="text" id="node-config-input-user" placeholder="postgres">
            </div>
            <div class="form-row">
                <label for="node-config-input-password"><i class="fa fa-lock"></i> <span>Password</span></label>
                <input type="password" id="node-config-input-password" placeholder="postgres">
            </div>
      </div>
      <div id="mydb-config-tab-pool" style="display: none;">
            <div class="form-row">
                <label title="Maximum number of physical database connections that this connection pool can contain." for="node-config-input-max" style="width: 150px;"><i class="fa fa-thermometer-full"></i> <span>Maximum size</span></label>
                <input type="number" id="node-config-input-max" placeholder="10">
            </div>
            <div class="form-row">
                <label title="Minimum number of physical database connections that this connection pool can contain." for="node-config-input-min" style="width: 150px;"><i class="fa fa-thermometer-empty"></i> <span>Minimum size</span></label>
                <input type="number" id="node-config-input-min" placeholder="1">
            </div>
            <div class="form-row">
                <label for="node-config-input-idle" style="width: 150px;"><i class="fa fa-hourglass-half"></i> <span>Idle Timeout</span></label>
                <input type="number" id="node-config-input-idle" placeholder="1000 (Milliseconds)">
            </div>
        </div>
    </div>
</script>
<script type="text/html" data-help-name="mydbConfig">
    <p>mydbConfig is the configuration node for mydb.</p>
  </script>
